/*
Copyright 2004 Cesar Tardaguila & Javier Tardaguila

This file is part of Drops.

Drops is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Srops is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Drops; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import net.designnation.data.*

class net.designnation.data.ListIteratorImpl extends List implements IIterator
{
	private var targetListVal: List;
	private var currentNode: Node= undefined;
	
	public function ListIteratorImpl( targetList: List )
	{		
		this.targetListVal= targetList;
		this.currentNode= this.targetListVal.head;
	}
	
	public function hasNext(  ): Boolean
	{
		return this.currentNode!= undefined;
	}
	
	public function next(  ): Object
	{		
		var retVal: Object= this.currentNode.value;
		this.currentNode= getNext(  );
		
		return retVal;
	}
		
	public function remove(  )
	{
	}
	
	private function getNext(  ): Node
	{
		var currentNodeAux: Node= this.currentNode;
		
		if( currentNodeAux!= undefined )
		{
			currentNodeAux= currentNodeAux.next;
		}
		return currentNodeAux;
	}
}